Program UserKonv;
{
***  Program pro uzivatelske konverse v DNC siti ***

Pouzije se, pokud je potreba do textoveho nebo strojoveho tvaru partprogramu
udelat nestandardni upravy, napr. vypustit nebo nahradit nejaky znak, doplnit
"blanky" do strojoveho kodu, pripsat znak konce souboru apod.
Pokud zadne upravy nejsou nutne, musi existovat v adresari DNC program
USERKONV.EXE, ktery nic neprovede. Prazdny USERKONV.EXE je na instalacni
diskete.
Program USERKONV.EXE lze napsat v jakemkoli jazyce (PASCAL,C, atd.).
Program dostane na prikazove radce tri parametry, podle kterych ridi
upravy a konverse pro jednotlive stroje.

 Program UserKonv se spousti se 3 parametry:

 1. parametr = retezec s uplnou cestou a nazvem souboru s partprogramem,
               ktery se ma upravit
 2. parametr = retezec s cislem stroje 1,2,3,...,10
 3. parametr = retezec, ktery urci misto, odkud je program volan, neboli
               typ upravy. V retezci je jedno z nasledujicich klicovych slov

    TEXT_IN  ... Uprava textu pred konversi do strojoveho tvaru a zarazeni
                 do adresare stroje. Uprava se provadi v adresari INOUT.
                 (TypUpravy = A)
    TEXT_OUT ... Uprava textu po konversi ze strojoveho tvaru do textoveho
                 tvaru a po presunu do adresare INOUT. Uprava se provadi
                 v adresari INOUT.
                 (TypUpravy = B)
    STROJ_IN ... Dodatecna uprava strojoveho tvaru (ISO,EIA) po konversi
                 z textu do strojoveho tvaru. Uprava se porovadi v adresari stroje.
                 (TypUpravy = C)
    STROJ_OUT... Dodatecna uprava strojoveho tvaru (ISO,EIA) pred konversi
                 ze strojoveho tvaru do textoveho tvaru. Uprava se provadi
                 v adresari stroje.
                 (TypUpravy = D)

 Priklady:
 UserKonv C:\DNC\INOUT\PPG1234.TXT 5 TEXT_IN
 Vola upravu programu PPG1234.TXT pro stroj cislo 5. Uprava se provede
 v textovem tvaru v adresari INOUT. Teprve po teto uprave se provede
 konverse z upraveneho textu do strojoveho tvaru.

 UserKonv C:\DNC\NS660\PPG1234.WTX 1 STROJ_IN
 Vola dodatecnou upravu strojoveho tvaru programu PPG1234.WTX pro stroj
 cislo 1. Uprava se provede po konversi z textu do strojoveho tvaru.

 UserKonv C:\DNC\WXH100NC\PPG1234.STX 2 STROJ_OUT
 Vola dodatecnou upravu strojoveho tvaru programu PPG1234.STX pro stroj
 cislo 2. Uprava se provede pred konversi ze strojoveho tvaru do textu.

 UserKonv C:\DNC\INOUT\PPG1234.TXT 5 TEXT_OUT
 Vola upravu programu PPG1234.TXT pro stroj cislo 5. Uprava se provede
 nasledne po konversi ze strojoveho tvaru do textu.

-------------------------------------------------------------------------
V nasledujicim programu je uvedena uprava partprogramu, ve kterem se
vsechna podtrzitka (_) nahradi mezerami. 
Radky, ktere neobsahuji znak ^ se zrusi, v radcich kde se vyskytne 
znak ^ se tento znak vymaze a tyto radky jsou platne pro partprogram.
Uprava se provede na urovni pred konversi z textu do strojoveho tvaru.
-------------------------------------------------------------------------

}

(*$I-*)
uses Dos;
label 8888,9999;
var
  Chyba: word;
  I,CisloStroje: byte;
  TypUpravy: char;
  UplneJmeno,PSoubor,Radek: string;
  FileText1,FileText2: text;
  FileBin1, FileBin2 : file;
  D: DirStr;
  N: NameStr;
  E: ExtStr;

Procedure OtevreTextoveSoubory;
begin
  Assign(FileText1,UplneJmeno);
  Reset(FileText1);  Chyba := IOResult;
  if Chyba <> 0 then Exit;

  { Vytvori pomocny soubor, do ktereho bude provadet upravy }
  { Pomocny soubor ma stejne jmeno ale priponu  $$$ }

  FSplit (UplneJmeno, D, N, E);
  PSoubor := D + N;
  if PSoubor[length(PSoubor)] = '.' then PSoubor := PSoubor + '$$$'
                                    else PSoubor := PSoubor + '.$$$';
  Assign(FileText2,PSoubor);
  Erase(FileText2);     Chyba := IOResult;   { pro jistotu vymaze }
  Rewrite(FileText2);   Chyba := IOResult;
end;

Procedure OtevreBinarniSoubory;
begin

end;

Procedure ProvedeUpravu(var Rad: string);
{ Zde si uzivatel udela potrebne upravy a vrati je v promenne Rad }
var
  PomString: string;
begin
  PomString := Rad;
  Rad := '';
  for I := 1 to length(PomString) do
  begin
    if PomString[I] = '_' then PomString[I] := ' ';  {nahradi podtrzitko mezerou }
    Rad := Rad + PomString[I];
  end;
{ zjistuje vyskyt ^ }
  I := Pos('^',Rad);
  if I = 0
    then Rad := ''
    else begin
           Delete(Rad,I,1);
           while I <> 0 do
             begin
               I := Pos('^',Rad);
               if I <> 0 then Delete(Rad,I,1);
             end;
         end;
end;
{**************************************************************************}
begin
  I := ParamCount;
  if I <> 3 then Goto 9999;

  UplneJmeno  := ParamStr(1);
  PSoubor     := ParamStr(2);
  if PSoubor[1] = '0' then CisloStroje := ord(PSoubor[2]) - $30
                      else CisloStroje := 10 + (ord(PSoubor[2]) - $30);
  PSoubor     := ParamStr(3);
  case PSoubor[7] of
    'N': TypUpravy := 'A';       { textove }
    'U': TypUpravy := 'B';       { textove }
    'I': TypUpravy := 'C';       { binarni }
    'O': TypUpravy := 'D';       { binarni }
  end;

  case TypUpravy of
  'A': begin
         case CisloStroje of
         1: begin
              OtevreTextoveSoubory;
              if Chyba <> 0 then Goto 8888;
              while NOT EOF(FileText1) do
              begin
                Readln(FileText1,Radek);
                ProvedeUpravu(Radek);
                if Radek <> '' then
                Writeln(FileText2,Radek);
              end;
              Close(FileText1); Chyba := IOResult;
              Close(FileText2); Chyba := IOResult;
              Erase(FileText1); Chyba := IOResult;
              Rename(FileText2,UplneJmeno); Chyba := IOResult;
              Goto 9999;
            end;
         2: begin                             { stroj cislo 2 }
            end;
         3: begin                             { stroj cislo 3 }
            end;
                                            { atd. pro dalsi stroje }
         end;  { end case cisla stroju }
       end;
  'B': begin
       end;
  'C': begin
       end;
  'D': begin
       end;
  end;

8888:
  Close(FileText1); Chyba := IOResult;
  Close(FileText2); Chyba := IOResult;
  Close(FileBin1);  Chyba := IOResult;
  Close(FileBin2);  Chyba := IOResult;
9999:
end.
